function varargout = camtia(varargin)
% camtia MATLAB code for camtia.fig
%      camtia, by itself, creates a new camtia or raises the existing
%      singleton*.
%
%      H = camtia returns the handle to a new camtia or the handle to
%      the existing singleton*.
%
%      camtia('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in camtia.M with the given input arguments.
%
%      camtia('Property','Value',...) creates a new camtia or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before camtia_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to camtia_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help camtia

% Last Modified by GUIDE v2.5 24-Nov-2016 00:22:12

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @camtia_OpeningFcn, ...
                   'gui_OutputFcn',  @camtia_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before camtia is made visible.
function camtia_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to camtia (see VARARGIN)

% Choose default command line output for camtia
handles.output = hObject;

% move GUI to the center
movegui(gcf,'center');

% clear command window
% clc

% save handles to mainGui and functions into root memory
setappdata(0,'handles_mainGui',gcf)                 % get handles to main GUI
setappdata(gcf, 'handles_updateAxes', @updateAxes)  % get handles to updateAxes(handles.axes1) function
set(0, 'DefaultFigureInvertHardCopy', 'off');       % printing figures with required background

% Add path to other folders
addpath(fullfile(pwd,'functions'))
addpath(fullfile(pwd,'settings'))
addpath(fullfile(pwd,'export'))
addpath(fullfile(pwd,'files'))

% Remove axis
axes(handles.axes1); % set the current axes to axes1
axis off

% prepare GUI and variables
handles_mainGui = getappdata(0,'handles_mainGui');

run setParameters
run initializeGUI

% initialize some variables
D(1).curImg = 1;
D(1).settingThreshold = false;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes camtia wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = camtia_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

run initializeGUI

D(1).projectName = inputdlg('Enter the project name:', 'Project name');
handles_title = findobj('Style','text','Tag','text2'); % find handle of static text
set(handles_title,'String', D(1).projectName) % update the static text field
set(handles_title,'Visible', 'on')

run setup
f = gcf;
waitfor(f);
setupStruct = load('selectedSetup.mat');
D(1).selectedSetup = setupStruct(1).selectedSetup;
[fileNames, inputPath] = uigetfile({'images/*.*'},'MultiSelect','on');
D(1).inputPath = inputPath;

nF = size(fileNames,2);
if length(char(fileNames(1))) > 1 
    for i = 1:nF
        D(i).files = [inputPath,char(fileNames(i))];
        D(i).fileNames = char(fileNames(i));
    end
else
    nF = 1;
    for i = 1:nF
        D(i).files = [inputPath,char(fileNames)];
        D(i).fileNames = char(fileNames);
    end
end
D(1).nFiles = nF;

set(gcf, 'pointer', 'watch')
drawnow;
% load the images
D(1).images = 0;
for j = 1:D(1).nFiles
    D(j).images = imread(D(j).files);
end

% calculate the tangents
progressbar(0)
for processedImage = 1:D(1).nFiles
    ref_img_clr = D(processedImage).images;
    if D(1).selectedSetup == 1
        run calculateTangents
    else
        run calculateTangents_2
    end
    progressbar(processedImage/D(1).nFiles)
end

% handles update
set(handles.togglebutton2,'Enable', 'on')
set(handles.pushbutton3,'Enable', 'on')
set(handles.pushbutton4,'Enable', 'on')
% set(handles.pushbutton5,'Enable', 'on')
if nF > 1
    set(handles.pushbutton6,'Enable', 'on')
end
set(handles.pushbutton7,'Enable', 'on')
set(handles.pushbutton8,'Enable', 'on')
set(handles.pushbutton9,'Enable', 'on')
set(handles.pushbutton10,'Enable', 'on')
set(handles.pushbutton11,'Enable', 'on')
set(handles.pushbutton12,'Enable', 'on')
set(handles.pushbutton13,'Enable', 'on')
set(handles.pushbutton14,'Enable', 'on')
set(handles.pushbutton15,'Enable', 'on')
set(handles.pushbutton16,'Enable', 'on')
set(handles.pushbutton17,'Enable', 'on')
set(handles.pushbutton18,'Enable', 'on')

handles_nImg = findobj('Style','text','Tag','text4'); % find handle of static text
set(handles_nImg,'String', sprintf('Image %d / %d',D(1).curImg, D(1).nFiles)) % update the static text field
set(handles_nImg,'Visible', 'on')

handles_actualImage = findobj('Style','text','Tag','text5'); % find handle of static text
set(handles_actualImage,'String', sprintf('File: %s',D(D(1).curImg).fileNames)) % update the static text field
set(handles_actualImage,'Visible', 'on')

set(gcf, 'pointer', 'arrow')

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
updateAxes(handles.axes1)

% --- Executes on button press in togglebutton2.
function togglebutton2_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of togglebutton2

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

set(gcf, 'pointer', 'watch')
drawnow;
if get(hObject,'Value')
    set(handles.slider1,'Enable', 'on')
    set(handles.pushbutton2,'Enable', 'off')
    set(handles.pushbutton3,'Enable', 'off')
    set(handles.pushbutton4,'Enable', 'off')
    set(handles.pushbutton5,'Enable', 'off')
    set(handles.pushbutton6,'Enable', 'off')
    set(handles.pushbutton7,'Enable', 'off')
    set(handles.pushbutton8,'Enable', 'off')
    set(handles.pushbutton9,'Enable', 'off')
    set(handles.pushbutton10,'Enable', 'off')
    set(handles.pushbutton11,'Enable', 'off')
    set(handles.pushbutton12,'Enable', 'off')
    set(handles.pushbutton13,'Enable', 'off')
    set(handles.pushbutton14,'Enable', 'off')
    set(handles.pushbutton15,'Enable', 'off')
    set(handles.pushbutton16,'Enable', 'off')
    set(handles.pushbutton17,'Enable', 'off')
    set(handles.pushbutton18,'Enable', 'off')
    handles_actualImage = findobj('Style','text','Tag','text5'); % find handle of static text
    set(handles_actualImage,'String', 'Setting brightness threshold for binarization') % update the static text field
    set(handles_actualImage,'ForegroundColor', [1,0,0]) % update the static text field
    set(handles_actualImage,'FontWeight', 'bold') % update the static text field
    D(1).settingThreshold = true;
else
    set(handles.slider1,'Enable', 'off')
    set(handles.pushbutton2,'Enable', 'on')
    set(handles.pushbutton3,'Enable', 'on')
    set(handles.pushbutton4,'Enable', 'on')
    set(handles.pushbutton5,'Enable', 'on')
    set(handles.pushbutton6,'Enable', 'on')
    set(handles.pushbutton7,'Enable', 'on')
    set(handles.pushbutton8,'Enable', 'on')
    set(handles.pushbutton9,'Enable', 'on')
    set(handles.pushbutton10,'Enable', 'on')
    set(handles.pushbutton11,'Enable', 'on')
    set(handles.pushbutton12,'Enable', 'on')
    set(handles.pushbutton13,'Enable', 'on')
    set(handles.pushbutton14,'Enable', 'on')
    set(handles.pushbutton15,'Enable', 'on')
    set(handles.pushbutton16,'Enable', 'on')
    set(handles.pushbutton17,'Enable', 'on')
    set(handles.pushbutton18,'Enable', 'on')
    handles_actualImage = findobj('Style','text','Tag','text5'); % find handle of static text
    set(handles_actualImage,'String', sprintf('File: %s',D(D(1).curImg).fileNames)) % update the static text field
    set(handles_actualImage,'ForegroundColor', [0,0,0]) % update the static text field
    set(handles_actualImage,'FontWeight', 'normal') % update the static text field
    D(1).settingThreshold = false;
    
    progressbar(0)
    for processedImage = 1:D(1).nFiles
        ref_img_clr = D(processedImage).images;
        if D(1).selectedSetup == 1
            run calculateTangents
        else
            run calculateTangents_2
        end
        progressbar(processedImage/D(1).nFiles)
    end
end

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of pushbutton3

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

outputPath = [char(D(1).inputPath(1:end-7)), 'export'];
if ~isequal(exist(strcat(outputPath,char(D(1).projectName)), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(outputPath,'/',char(D(1).projectName)))
end

tempFigure = figure;
axTemp = axes;
updateAxes(axTemp)
print(tempFigure,'-dpng',strcat(outputPath,'/',char(D(1).projectName),'/',char(D(1).fileNames)))
close(tempFigure)

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

set(gcf, 'pointer', 'watch')
drawnow;

outputPath = [char(D(1).inputPath(1:end-7)), 'export'];
if ~isequal(exist(strcat(outputPath,char(D(1).projectName)), 'dir'),7) % check whether the destination folder exists
    mkdir(strcat(outputPath,'/',char(D(1).projectName)))
end

fileName = strcat(outputPath,'/',char(D(1).projectName),'/',char(D(1).projectName),'.xlsx');
A = {'Image','angle 1','angle 2'};
xlswrite(fileName,A,1,'A1')

B = [];
for i = 1:D(1).nFiles
    B = [B; [i, D(i).slope_1, D(i).slope_2]];
end
xlswrite(fileName,B,1,'A2')
set(gcf, 'pointer', 'arrow')

msgbox('Project data saved to "export" folder.');

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(1).curImg = D(1).curImg-1;

if D(1).curImg == D(1).nFiles
    set(handles.pushbutton6, 'Enable', 'off')
    set(handles.pushbutton5, 'Enable', 'on')
elseif D(1).curImg == 1
    set(handles.pushbutton5, 'Enable', 'off')
    set(handles.pushbutton6, 'Enable', 'on')
else
    set(handles.pushbutton5, 'Enable', 'on')
    set(handles.pushbutton6, 'Enable', 'on')
end

handles_actualImage = findobj('Style','text','Tag','text5'); % find handle of static text
set(handles_actualImage,'String', sprintf('File: %s',D(D(1).curImg).fileNames)) % update the static text field
set(handles_actualImage,'Visible', 'on')

handles_nImg = findobj('Style','text','Tag','text4'); % find handle of static text
set(handles_nImg,'String', sprintf('Image %d / %d',D(1).curImg, D(1).nFiles)) % update the static text field
set(handles_nImg,'Visible', 'on')

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
updateAxes(handles.axes1)

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(1).curImg = D(1).curImg+1;

if D(1).curImg == D(1).nFiles
    set(handles.pushbutton6, 'Enable', 'off')
    set(handles.pushbutton5, 'Enable', 'on')
elseif D(1).curImg == 1
    set(handles.pushbutton5, 'Enable', 'off')
    set(handles.pushbutton6, 'Enable', 'on')
else
    set(handles.pushbutton5, 'Enable', 'on')
    set(handles.pushbutton6, 'Enable', 'on')
end

handles_actualImage = findobj('Style','text','Tag','text5'); % find handle of static text
set(handles_actualImage,'String', sprintf('File: %s',D(D(1).curImg).fileNames)) % update the static text field
set(handles_actualImage,'Visible', 'on')

handles_nImg = findobj('Style','text','Tag','text4'); % find handle of static text
set(handles_nImg,'String', sprintf('Image %d / %d',D(1).curImg, D(1).nFiles)) % update the static text field
set(handles_nImg,'Visible', 'on')

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
updateAxes(handles.axes1)

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P1(2) = D(D(1).curImg).P1(2)-D(1).motionStep;
D(D(1).curImg).y1 = D(D(1).curImg).y1-D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P1(1) = D(D(1).curImg).P1(1)-D(1).motionStep;
D(D(1).curImg).x1 = D(D(1).curImg).x1-D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton9.
function pushbutton9_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P1(2) = D(D(1).curImg).P1(2)+D(1).motionStep;
D(D(1).curImg).y1 = D(D(1).curImg).y1+D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P1(1) = D(D(1).curImg).P1(1)+D(1).motionStep;
D(D(1).curImg).x1 = D(D(1).curImg).x1+D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton11.
function pushbutton11_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).slope_1 = D(D(1).curImg).slope_1+D(1).rotationStep;
dy_dx = tand(90-D(D(1).curImg).slope_1);
sl = atand(dy_dx);
D(D(1).curImg).x1 = [D(D(1).curImg).P1(1)+D(D(1).curImg).radius*cosd(-sl), D(D(1).curImg).P1(1)-D(D(1).curImg).radius*cosd(-sl)];
D(D(1).curImg).y1 = [D(D(1).curImg).P1(2)+D(D(1).curImg).radius*sind(-sl), D(D(1).curImg).P1(2)-D(D(1).curImg).radius*sind(-sl)];

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton12.
function pushbutton12_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).slope_1 = D(D(1).curImg).slope_1-D(1).rotationStep;
dy_dx = tand(90-D(D(1).curImg).slope_1);
sl = atand(dy_dx);
D(D(1).curImg).x1 = [D(D(1).curImg).P1(1)+D(D(1).curImg).radius*cosd(-sl), D(D(1).curImg).P1(1)-D(D(1).curImg).radius*cosd(-sl)];
D(D(1).curImg).y1 = [D(D(1).curImg).P1(2)+D(D(1).curImg).radius*sind(-sl), D(D(1).curImg).P1(2)-D(D(1).curImg).radius*sind(-sl)];

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton13.
function pushbutton13_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P2(2) = D(D(1).curImg).P2(2)-D(1).motionStep;
D(D(1).curImg).y2 = D(D(1).curImg).y2-D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P2(1) = D(D(1).curImg).P2(1)-D(1).motionStep;
D(D(1).curImg).x2 = D(D(1).curImg).x2-D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')


% --- Executes on button press in pushbutton15.
function pushbutton15_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P2(2) = D(D(1).curImg).P2(2)+D(1).motionStep;
D(D(1).curImg).y2 = D(D(1).curImg).y2+D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton16.
function pushbutton16_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton16 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).P2(1) = D(D(1).curImg).P2(1)+D(1).motionStep;
D(D(1).curImg).x2 = D(D(1).curImg).x2+D(1).motionStep;

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton17.
function pushbutton17_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).slope_2 = D(D(1).curImg).slope_2+D(1).rotationStep;
dy_dx = tand(90-D(D(1).curImg).slope_2);
sl = atand(dy_dx);
D(D(1).curImg).x2 = [D(D(1).curImg).P2(1)+D(D(1).curImg).radius*cosd(-sl), D(D(1).curImg).P2(1)-D(D(1).curImg).radius*cosd(-sl)];
D(D(1).curImg).y2 = [D(D(1).curImg).P2(2)+D(D(1).curImg).radius*sind(-sl), D(D(1).curImg).P2(2)-D(D(1).curImg).radius*sind(-sl)];

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')

% --- Executes on button press in pushbutton18.
function pushbutton18_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton18 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(D(1).curImg).slope_2 = D(D(1).curImg).slope_2-D(1).rotationStep;
dy_dx = tand(90-D(D(1).curImg).slope_2);
sl = atand(dy_dx);
D(D(1).curImg).x2 = [D(D(1).curImg).P2(1)+D(D(1).curImg).radius*cosd(-sl), D(D(1).curImg).P2(1)-D(D(1).curImg).radius*cosd(-sl)];
D(D(1).curImg).y2 = [D(D(1).curImg).P2(2)+D(D(1).curImg).radius*sind(-sl), D(D(1).curImg).P2(2)-D(D(1).curImg).radius*sind(-sl)];

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');

D(1).binarizationLimit = get(hObject,'Value');

setappdata(handles_mainGui, 'D', D);
setappdata(handles_mainGui, 'handles', handles);
set(gcf, 'pointer', 'watch')
drawnow;
updateAxes(handles.axes1)
set(gcf, 'pointer', 'arrow')


% --- Executes during object creation, after setting all properties.
function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


%% Function to update axes
function updateAxes(ax)
handles_mainGui = getappdata(0,'handles_mainGui');
D = getappdata(handles_mainGui, 'D');
handles = getappdata(handles_mainGui, 'handles');

axes(ax) % to work with axes1

if ~D(1).settingThreshold
    imshow(D(D(1).curImg).images)
    hold on
    plot(D(D(1).curImg).P1(1),D(D(1).curImg).P1(2),'+w','MarkerSize',12,'LineWidth',1)
    plot(D(D(1).curImg).P2(1),D(D(1).curImg).P2(2),'+w','MarkerSize',12,'LineWidth',1)
    plot(D(D(1).curImg).x1,D(D(1).curImg).y1,'-w','LineWidth',2)
    plot(D(D(1).curImg).x2,D(D(1).curImg).y2,'-w','LineWidth',2)
    
    if D(1).selectedSetup == 1
        txt1 = sprintf('%.2f    ',D(D(1).curImg).slope_1);
        text(D(D(1).curImg).P1(1),D(D(1).curImg).P1(2),txt1,'HorizontalAlignment','right','fontsize',18,'Color', [1,1,1])
        txt2 = sprintf('    %.2f',D(D(1).curImg).slope_2);
        text(D(D(1).curImg).P2(1),D(D(1).curImg).P2(2),txt2,'HorizontalAlignment','left','fontsize',18,'Color',[1,1,1])
    else
        txt1 = sprintf('    %.2f',D(D(1).curImg).slope_1);
        text(D(D(1).curImg).P1(1),D(D(1).curImg).P1(2),txt1,'HorizontalAlignment','left','fontsize',18,'Color', [1,1,1])
        txt2 = sprintf('%.2f    ',D(D(1).curImg).slope_2);
        text(D(D(1).curImg).P2(1),D(D(1).curImg).P2(2),txt2,'HorizontalAlignment','right','fontsize',18,'Color',[1,1,1])
    end
    hold off
else
    ref_img_clr = D(D(1).curImg).images;
    ref_img = 0.2989*ref_img_clr(:,:,1)+0.5870*ref_img_clr(:,:,2)+0.1140*ref_img_clr(:,:,3); 
    ref_img_bw = im2bw(ref_img, D(1).binarizationLimit);
    imshow(ref_img_bw)
end
